tinyMCE.importPluginLanguagePack('bgcolor', 'en'); // <- Add a comma separated list of all supported languages

// Singleton class
var TinyMCE_BgColorPlugin = {
	/**
	 * Returns information about the plugin as a name/value array.
	 * The current keys are longname, author, authorurl, infourl and version.
	 *
	 * @returns Name/value array containing information about the plugin.
	 * @type Array 
	 */
	getInfo : function() {
		return {
			longname : 'Background color change',
			author : 'Botmonster',
			authorurl : 'http://botmonster.be/tiny',
			infourl : 'http://botmonster.be/tiny/bgcolor.html',
			version : "1.0"
		};
	},


	
	getControlHTML : function(cn) {
		switch (cn) {
			case "bgcolor":
				return tinyMCE.getButtonHTML(cn, 'lang_theme_backcolor_desc', '{$pluginurl}/images/bgcolor.gif', 'mceBgColor', true);
		}

		return "";
	},

	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			// Remember to have the "mce" prefix for commands so they don't intersect with built in ones in the browser.
			case "mceBgColor":
				// Show UI/Popup
				if (user_interface) {
					var template = new Array();
					var inputColor;
					if (inputColor == '')
						inputColor = elm.style.color;
	
					if (!inputColor)
						inputColor = "#000000";
	
					template['file'] = 'color_picker.htm';
					template['width'] = 220;
					template['height'] = 190;
	
					tinyMCE.openWindow(template, {editor_id : editor_id, inline : "yes", command : "setBgColor", input_color : inputColor});
					// Let TinyMCE know that something was modified
					tinyMCE.triggerNodeChange(false);
				} else {

				}
					return true;
				case 'setBgColor':
					tinyMCE.getInstanceById(editor_id).contentDocument.body.style.backgroundColor = value;
					//tinyMCE.getInstanceById(editor_id).getDoc().body.innerHTML = '<div style="width:100%;height:100%;background:'+value+'"></div>';
					
				return true;
		}

		// Pass to next handler in chain
		return false;
	}
	

};

// Adds the plugin class to the list of available TinyMCE plugins
tinyMCE.addPlugin("bgcolor", TinyMCE_BgColorPlugin);
